/*
 *
 * (c) Copyright 1992 by William R. Pringle - all rights reserved
 *
 *				**** ALBUM ****
 *
 * EMACS_MODES: c, tabstop=4, !lnumb, !fill
 *
 * This file allows the user to get info on albums
 *
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "cd.h"

main(argc,argv)
int	argc;
char	**argv;
{
	char	buf[BUFSIZ];			/* input buffer */

	char	*p;
	int		i;
	int		option;
	int		looping;

		/* get my name in lower case w/o full path name */
	p = argv[0] + strlen(argv[0]) - 1;		/* last char */
	while (p >argv[0] && *p != '/' && *p != '\\') p--;
	Prog = (p == argv[0]) ? p : ++p;
	while (*p != EOS)
	{
		if (isupper(*p)) *p = tolower(*p);
		p++;
	}
	argc--;			/* shift program name out */
	argv++;

	help_init("albums.hlp");


	if (argc > 0)
	{
		mast_name = getcore(argv[0]);
		argc--;
		argv++;
		printf("Using mast file %s\n", mast_name);
	} else {
		printf("Do you want help? (y or n): ");
		gets(buf);
		if (*buf == 'y' || *buf == 'Y')
		{
			help("INTRO");
			exit(0);
		}

		printf("Enter master file name: ");
		gets(buf);
		p = clean_up(buf);
		if (*p == EOS) exit(0);
		else mast_name = getcore(buf);
	}

	init();

	for (option = 'm', looping=1; looping > 0; )
	{
		if (option == EOS)
		{			/* loop until exit option */
			printf("\n\nOptions:\n\n");
			printf("B\tBrowse through Database\n");
			printf("M\tSelect Master File\n");
			printf("K\tKeep Albums\n");
			printf("F\tFind Cuts\n");
			printf("T\tConfigure Tape\n");
			printf("C\tList Configuration\n");
			printf("S\tSave Tape Configuration\n");
			printf("L\tLoad Tape Configuration\n");
			printf("\n");
			printf("?\tHelp Message\n");
			printf("X\tExit program\n");

			printf("Enter option: ");
			gets(buf);
			p = clean_up(buf);
			if (*p == EOS) continue;
			option = *p;
		}

	switch(option) {
		case 'b':			/* browse */
		case 'B':
			option = do_browse();
			break;

				/* display configuration */
		case 'c':
		case 'C':
			printf("\n\nMaster file is %s\n", mast_name);
			printf("\tdatabase has %d files containing %ld albums\n", tot_dat, tot_albums);
			printf("\t"); tape_len();		/* indent printout */

			if (tkeep > 0)
			{
				printf("%s: %d albums kept so far:\n", Prog, tkeep);
				list_albums(stdout,1);
			} else printf("No albums kept yet\n\n");
			option = EOS;
			break;

					/* find cuts */
		case 'f':
		case 'F':
			do_song();		/* search by songs */
			option = EOS;				/* prompt for new option */
			break;

					/* keep albums */
		case 'k':
		case 'K':
			option = get_albums();				/* load keep array */
			break;

					/* load configuration */
		case 'l':
		case 'L':
			load_config();
			option = EOS;
			break;

		case 'm':		/* select master file */
		case 'M':
			if (*mast_name == EOS)
			{			/* not very first time */
				free
				(mast_name);		/* free space */
				printf("Enter Master File Name: ");
				gets(buf);
				p = clean_up(buf);
				if (*p == EOS) continue;
				else mast_name = getcore(buf);

					/* starting new master, close old files */
				for (i=0; i < tot_dat; i++)
				{		/* close old index/data files */
					close_dat(i);
				}

				init();		/* reset things */
			}

			open_mast(mast_name);
			tkeep = 0;					/* not keeping any albums yet */
			option = EOS;				/* prompt for new option */
			break;

		case 'q':			/* quit from a child menu */
		case 'Q':
			option = EOS;	/* prompt for new command */
			continue;

					/* save configuration */
		case 's':
		case 'S':
			dump_config();
			option = EOS;
			break;

				 /* configure tape */
		case 't':
		case 'T':
			option = make_tape();			/* configure tape */
			break;

		case 'x':			/* exit */
		case 'X':
			printf("Exit? (y or n): ");
			gets(buf);
			option = EOS;	/* prompt for new command if needed */
			if (*buf == 'y' || *buf == 'Y') looping = 0;
			continue;

		case '?':	/* help message */
			help("MAIN");
			option = EOS;
			break;

		default:			/* invalid option */
			printf("Invalid option.  Try again\n");
			option = EOS;
			break;
		}	/* end option loop */
	}		/* end of command loop */

	for (i=0; i < tot_dat; i++)
	{		/* loop thru index/data files */
		close_dat(i);
	}
	return 0;
}
