#!/usr/local/pub/bin/gawk -f
# this script displays the title & name in 80 chars max.

BEGIN {
	FS = "|"

	# album line

	ARTIST		= 1		# name of artist
	TITLE		= 2		# title of album
	DATE		= 3		# date published
	LABEL		= 4		# label name
	CATALOG		= 5		# catalogue number

	# cut line
	CUTNAME		= 1		# name of cut
	TIME		= 2		# time of cut
	CUTART		= 3		# artist, if different than album line

	# max fields
	MAXLEN		= 79	# max size
	MAXART		= 10	# max. artist size
	MAXTIT		= 10	# max. title size

	LETTER = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
}

substr($0,1,1) == "\t" { next }		# skip cut lines

{		# album line
	if (FILENAME != LASTFILE)
	{		# new file - display file name
		Name = FILENAME
		if (Name == "popa.alb") Name = "pop"
		if (substr(Name,1,3) != "pop" || substr(Name,5) != ".alb")
			printf "***%s\n\n", Name
		LASTFILE = FILENAME
	}

	Artist = ""
	x = length($ARTIST)
	if ($ARTIST == "Various") x = 0	# skip various artist
	
	for (i=1; i <= x; i++)
	{
		c = substr($ARTIST,i,1)
		if (c == "~") break
		if (index(LETTER,c)>0) Artist = Artist c
	}
	
	Title = ""
	x = length($TITLE)
	for (i=1; i <= x; i++)
	{
		c = substr($TITLE,i,1)
		if (c == "~") break
		if (index(LETTER,c)>0) Title = Title c
	}

	alen = length(Artist)
	tlen = length(Title)
	if (tlen == 0) next

	if (alen > MAXART) Artist = substr(Artist,1,MAXART)
	if (tlen > MAXTIT) Title = substr(Title,1,MAXTIT)

	print Artist "|" Title "|" $CATALOG
	print ""
}

func Time(str) {		# compute time in seconds
	if ((x = split(str,Flds,":")) != 2) return 0
	else return (Flds[1] * 60 + Flds[2])
}

func PrtAlb() {	# print last album
	print Album "|" OutTime(TotTime)
}

func OutTime(str) {		# convert seconds to Min:Sec
	Sec = str % 60
	Min = (str - Sec) / 60

	return (Min ":" Sec)
}

func CleanUp(str) {	# clean CR from line if there
	if (substr(str,length(str)) == "\r") ret = substr(str,1,length(str)-1)
	else ret = str
	return ret
}
