#!/bin/awk
# This script extracts all entries for a given artist

BEGIN {	# set up
	# define positional fields
	FS = "|"	# field delimeter

	# album record
	ALB_ART		= 1		# album artist
	ALB_TIT		= 2		# album title
	ALB_YR		= 3		# year of album
	ALB_LBL		= 4		# label
	ALB_NUM		= 5		# catalogue number
	ALB_FLDS	= 5		# number of fields

	# cut record
	CUT_TIT		= 1		# cut title
	CUT_TIME	= 2		# cut time
	CUT_ART		= 3		# cut artist
	CUT_FLDS	= 3		# number of fields
}

NF == ALB_FLDS {		# new album
	LastAlb = $0	# save album record
	Fnd = 0		# reset found switch
	nflds = split($ALB_ART,fld,"~")
	for (i=1; i <= nflds; i++)
	{		# loop thru artists
		if (fld[i] == ARTIST)
		{	# artist matches - signal found
			Fnd = 1
		}
	}
}

NF == CUT_FLDS && Fnd != 1 {	# cut line w/ an artist, but not found
	# album not be artist, check for guest artist field
	nflds = split($CUT_ART,fld,"~")
	for (i=1; i <= nflds; i++)
	{		# loop thru artists
		if (fld[i] == ARTIST)
		{		# artist matches - print entry
			# print album record if first time
			if (Fnd == 0) print LastAlb
			Fnd = 2		# signal found for cut
			print $0	# print cut title
			break		# print only once
		}
	}
}

Fnd == 1 {	print $0 }	# print if found
