/*
 *				**** DO SONG ****
 *
 * (c) Copyright 1992 by William R. Pringle - all rights reserved
 *
 * This function searches for songs that match what the user enters
 *
 */

#include <stdio.h>
#include "cd.h"

#define PAGESIZ	10	/* how many finds per screen */

 do_song()
 {		/* find songs */
	char	buf[BUFSIZ];		/* input buffer */
	char	*p;					/* parsing */
	char	*key;				/* key string */
	struct	key_match	key_match[MAXMATCH];	/* key match area */
	int		nmatch;				/* number of matches */
	int		i;					/* loop variable */
	int		fnum;				/* file number */
	long	datloc;				/* location of album within data file */
	long	cutloc;				/* location of cut/song within data file */

	datloc = cutloc = 0L;

	while (1)
	{
		printf("Enter name of song to find, or ENTER to quit: ");
		gets(buf);		/* get song name */
		p = clean_up(buf);
		if (*p == EOS) break;		/* quit */

		key = get_key(p);		/* convert song name to search key */
		nmatch = find_key(cut_file,key,key_match,MAXMATCH);
		printf("%d matches for key string >>%s<<\n", nmatch, key);

		for (i=0; i < nmatch; i++)
		{		/* loop thru files */
			fnum = key_match[i].km_file;		/* file number */
			datloc = key_match[i].km_loc;		/* location of album */
			cutloc = key_match[i].km_cut;		/* location of cut/song */

			open_dat(fnum);		/* open data file */
			if (fseek(datafile[fnum].df_fp,datloc,SEEK_SET) != 0)
			{
				fprintf(stderr,"%s: Could not seek to record %ld in data file %d!\n",
							Prog, key_match[i].km_rec, key_match[i].km_file);
				perror(Prog);
				continue;
			}

			/* positioned to album line - read it  */
			if (fgets(buf,sizeof(buf),datafile[fnum].df_fp) == NULL)
			{
				fprintf(stderr,"%s: Unable to read record at location %ld if file %d\n",
								Prog, datloc, fnum);
				perror(Prog);
				exit(3);
			}

			p = clean_up(buf);		/* clean up record */
			printf("%4d - %s\n", i+1, p);

			if (fseek(datafile[fnum].df_fp,cutloc,SEEK_SET) != 0)
			{
				fprintf(stderr,"%s: Can't seek to cut for record %ld in file %d!\n",
							Prog, key_match[i].km_rec, key_match[i].km_file);
				exit(4);
			}

			if (fgets(buf,sizeof(buf),datafile[fnum].df_fp) == NULL)
			{
				fprintf(stderr,"%s: Can't read record %ld from file %d!\n",
							Prog, key_match[i].km_rec, key_match[i].km_file);
				exit(5);
			}

			p = clean_up(buf);
			printf("\t%s\n", p);
			if ((i % PAGESIZ) == (PAGESIZ-1))
			{		/* full screen - pause */
				printf("Press ENTER to continue: ");
				gets(buf);
				if (*buf == 'q') break;
			}
		}	/* end loop thru matches */
		if ((i % PAGESIZ) == (PAGESIZ-1))
		{
			printf("Press ENTER to continue: ");
			gets(buf);
		}
	}
}
