/*
 *
 * (c) Copyright 1992 by William R. Pringle - all rights reserved
 *
 *				**** PARSE NUM ****
 *
 * This routine will parse a string of numbers into ranges
 *	and return these ranges in two integer arrays
 *
 */

#ifndef EOS
#define	EOS	'\0'
#endif

#include <ctype.h>

parse_nums(str,num1,num2,maxnum)
char	*str;			/* input string to parse */
int		num1[];			/* beginning line number to return */
int		num2[];			/* ending line number to return */
int		maxnum;			/* maximum number of ranges to return */
{
	char	*p, *q;		/* a good old pointer variables */
	int	nents;			/* how many pairs of lines */
	char	buf[16];	/* buffer for conversion */

	p = str;			/* start with string */
	nents = 0;			/* number of line pairs */

	while (*p != EOS && nents < maxnum)
	{		/* must start with numeric digit */
		while (isspace(*p)) p++;		/* find first non-blank */
		if (! isdigit(*p)) return 0;	/* bad first value */
		for (q=buf; isdigit(*p); *q++ = *p++);
		while (isspace(*p)) p++;		/* skip to next non-blank */
		if (*p != '-' && *p!= ':' && *p != ',' && *p != EOS && !isdigit(*p)) return 0;
		*q = EOS;		/* terminate buffer string */
		num1[nents] = atoi(buf);			/* first number */

		if (*p == '-' || *p == ':')
		{		/* range of numbers given, get second number */
			for (p++; isspace(*p); p++);	/* find next non-blank */
			if (!isdigit(*p)) return 0;		/* garbage for a number */
			for (q=buf; isdigit(*p); *q++ = *p++);	/* end of second number */
			while (isspace(*p)) p++;		/* skip past white space */
			if (*p != ',' && *p != EOS) return 0;	/* wrong terminator */
			*q = EOS;
			num2[nents] = atoi(buf);			/* end line */
		} else num2[nents] = num1[nents];	/* same as begin */

		nents++;							/* incr. number of entries */
		if (*p == ',') p++;					/* point past delimeter */
	}		/* end loop thru string */

	if (*p == EOS) return nents;			/* all O.K. */
	else return -1;							/* too many ranges in string */
 }
